import qbs

Product {
    type: ["application","flash"]
    Depends { name: "cpp" }
    name: "firmware"
    cpp.assemblerFlags: ["-plosgffwy"]

    files: [
        "system.h",
        "gpio.h",
        "gpio.c",
        "main.c",
		"delay.s",
    ]    

    Properties
    {
        condition: qbs.buildVariant === "debug"
		cpp.cFlags: ["--out-fmt-elf"]
		cpp.driverLinkerFlags: ["--debug","--out-fmt-elf"]
		cpp.executableSuffix: ".elf"
    }

    Properties
    {
        condition: qbs.buildVariant === "release"
        cpp.cFlags: ["--opt-code-size"]
        cpp.executableSuffix: ".ihx"
    }

    Rule
    {
        inputs: ["application"]
        Artifact
        {
            filePath: product.name
            fileTags: "flash"
        }
        prepare:
        {
            var size_name=input.filePath
            var cmd=new Command("stm8-size",size_name)
            cmd.description = "print size of the firmware"
            return [cmd]
        }
    }
}
